import { ContextValue, SyntaxHandler, ScriptContext, SyntaxNode } from '../common';
export interface OperatorDefinition {
    symbol: string;
    priority: number;
    ltr: boolean;
    handler: SyntaxHandler;
}
export declare const evalBinaryOperation: <T extends ContextValue, U extends ContextValue>(a: ContextValue, b: ContextValue, magicName: string | null, typeA: string | null, typeB: string | null, defaultHandler: (a: T, b: U) => ContextValue, buffer: SyntaxNode[], index: number, context: ScriptContext) => ContextValue;
export declare const evalUnaryOperation: <T extends ContextValue>(value: ContextValue, magicName: string | null, type: string | null, defaultHandler: (value: T) => ContextValue, buffer: SyntaxNode[], index: number, context: ScriptContext) => ContextValue;
export declare const createBinaryOperator: <T extends ContextValue, U extends ContextValue>(magicName: string | null, typeA: string | null, typeB: string | null, defaultHandler: (a: T, b: U) => ContextValue) => SyntaxHandler;
export declare const createUnaryOperator: <T extends ContextValue>(magicName: string | null, type: string | null, defaultHandler: (value: T) => ContextValue) => SyntaxHandler;
export declare const createAdditionalAssignmentOperator: <T extends ContextValue, U extends ContextValue>(magicName: string | null, typeA: string | null, typeB: string | null, defaultHandler: (a: T, b: U) => ContextValue) => SyntaxHandler;
